import QtQuick 1.0
import com.nokia.meego 1.0

ToolBarLayout {
    id: commonTools
    visible: true
    signal buttonClicked(string name);
    signal backClicked;
    signal refreshDropBox;
    property real pageStackDepth: (db.readFirstTime())? 3: 2


    Image{
        anchors.fill: parent
        source:"res/footer.png"
    }

    ToolIcon {
        id:backIcon
        platformStyle:ToolItemStyle{pressedBackground: Qt.resolvedUrl("res/squircle.png")}
        iconSource: "res/back.png"
        anchors.left: parent.left
        opacity: (appWindow.pageStack.depth > pageStackDepth || directoryModel.count > 1)? 1.0:0.5
        onClicked: {
            if (page.name =="searchResultPage" && searchDirectoryModel.count > 1||page.name == "directoryPage" && directoryModel.count>1 || page.name=="uploadPage" && uploadModel.count>1)
                backClicked();
            else if(appWindow.pageStack.depth > pageStackDepth)
                pageStack.pop()
        }
    }

    ToolIcon {
        id:searchIcon
        platformStyle:ToolItemStyle{pressedBackground: Qt.resolvedUrl("res/squircle.png")}
        iconSource: "res/search.png"
        anchors.left: backIcon.right
        anchors.leftMargin: 20
        onClicked: {buttonClicked("search");}
    }

    ToolIcon{
        id:refreshIcon
        platformStyle:ToolItemStyle{pressedBackground: Qt.resolvedUrl("res/squircle.png")}
        iconSource: "res/refresh.png"
        anchors.left: searchIcon.right
        anchors.leftMargin: 20
        onClicked: {refreshDropBox()}
    }

    ToolIcon{
        id:settingIcon
        platformStyle:ToolItemStyle{pressedBackground: Qt.resolvedUrl("res/squircle.png")}
        iconSource: "res/settings.png"
        anchors.left: refreshIcon.right
        anchors.leftMargin: 20
        onClicked: {appState.findPage(settingPage,"settingPage")}
    }

    ToolIcon{
        id:uploadIcon
        platformStyle:ToolItemStyle{pressedBackground: Qt.resolvedUrl("res/squircle.png")}
        iconSource: "res/upload.png"
        anchors.left: settingIcon.right
        anchors.leftMargin: 20

        onClicked: {appState.findPage(uploadPage,"uploadPage")}
    }
}
