import QtQuick 1.0
import "HelperFunctions.js" as HF
import "sha1.js" as SHA1
import "auth.js" as Auth

Item{
    id:dropBoxAuth
    property string appKey : "bebvqasko9ry1ll"//k3kab28jc2sr8j5";
    property string appSecret : "dhr7meb4i6xtebo"//ymfggigr9ekiv9x";

    function getOAuthRequest(type, url, authParameters, credentials, parameters, body) {

        var params = getOAuthParameter(type, url, authParameters, credentials, parameters, body);
        var xhr = new XMLHttpRequest;
        xhr.open(type, params.requrl);
        xhr.setRequestHeader("Authorization", params.header);
        xhr.setRequestHeader("Accept-Language", "en");
        xhr.setRequestHeader("User-Agent", "NokiaBrowser/8.50");

        return xhr;
    }


    function nativeOAuthRequest(type, url, authParameters, credentials, parameters, body) {

        var params = getOAuthParameter(type, url, authParameters, credentials, parameters, body);
        return params;
    }

    function authorizeApplication(email, password, reauthenticate) {
        // check if reauthenticate then, try accesstokens otherwise get request tokens
        if(reauthenticate){
            authenticate(accessToken, accessTokenSecret, email, password);
        }else{
            authenticate(requestToken, requestTokenSecret, email, password);
        }
    }

    function startReauthenticate()
    {
        appState.findPage(mainPage,"mainPage")
        banner.show();
        banner.text = "Authentication Failed"
    }

    // use authentication method to retrieve token and secret
    function authenticate(token, secret, email, password){
        var req = getOAuthRequest("POST", "https://api.dropbox.com/0/token",null, {"token":token,"secret":secret}, [["email",email], ["password",password]]);
        req.setRequestHeader("Host", "https://api.dropbox.com");
        req.onreadystatechange = function() {
            if (req.readyState == XMLHttpRequest.DONE) {
                loadingScreen.show = false;
                if(HF.isDefined(req.responseText) && req.responseText !== ""){
                    var responseData = JSON.parse(req.responseText);
                    if(HF.isDefined(responseData.token) && HF.isDefined(responseData.secret)){
                        accessToken = responseData.token;
                        accessTokenSecret = responseData.secret;
                        db.saveUserInfo(accessToken,accessTokenSecret)
                        appState.findPage(directoryPage,"directoryPage")
                    }
                }else{
                    banner.show();
                }
            }
        }
        req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        req.send();
    }

    function getRequestToken(email,password)
    {
        var req = getOAuthRequest("POST",'http://api.dropbox.com/0/oauth/request_token');

        req.onreadystatechange= function(){
            if (req.readyState === XMLHttpRequest.DONE) {
                var response = req.responseText.split('&');
                if(response.length > 1){

                    var tokenSecretPos = (response[0].split('=')[0] == "oauth_token_secret")? 0 : 1;
                    var tokenPos = (tokenSecretPos === 0)? 1 : 0;
                    requestToken = response[tokenPos.valueOf()].split('=')[1];
                    requestTokenSecret = response[tokenSecretPos.valueOf()].split('=')[1];
                    authorizeApplication(email,password,false)
                }
            }
        }

        req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        req.send();
    }


    function getOAuthParameter(type, url, authParameters, credentials, parameters, body)
    {
        var timestamp =HF.getTime();
        var nonce = HF.getNonce();

        var parameterList = new Array();


        parameterList.push(["oauth_consumer_key",appKey])
        parameterList.push( ["oauth_nonce", nonce] );
        parameterList.push( ["oauth_timestamp", timestamp] );
        parameterList.push( ["oauth_signature_method", "HMAC-SHA1"] );
        parameterList.push( ["oauth_version", "1.0"] );
        if (credentials)
            parameterList.push( ["oauth_token", credentials.token] );

        if (authParameters)
            parameterList = parameterList.concat(authParameters);

        if (parameters)
            parameterList = parameterList.concat(parameters);

        parameterList.sort(function(a,b) {
                               if (a[0] < b[0]) return  -1;
                               if (a[0] > b[0]) return 1;
                               if (a[1] < b[1]) return -1;
                               if (a[1] > b[1]) return 1;
                               return 0;
                           });

        var normalized = "";

        if(body)
            normalized = body + "&";
        for (var ii = 0; ii<parameterList.length; ++ii){
            if(ii != 0) normalized += "&";
            normalized += parameterList[ii][0] + "=" + HF.percentEncode(parameterList[ii][1]);
        }

        var basestring = type + "&" + HF.percentEncode(url) + "&" + HF.percentEncode(normalized);
        var keystring = HF.percentEncode(appSecret) + "&";

        if (credentials)
                keystring += HF.percentEncode(credentials.secret);

        var signature = SHA1.b64_hmac_sha1(keystring, basestring);

        var authHeader = "OAuth ";
        authHeader += "oauth_consumer_key=\"" + HF.percentEncode(appKey) + "\"";
        authHeader += ", oauth_nonce=\"" + HF.percentEncode(nonce) + "\"";
        authHeader += ", oauth_timestamp=\"" + HF.percentEncode(timestamp) + "\"";
        authHeader += ", oauth_signature=\"" + HF.percentEncode(signature) + "\"";
        authHeader += ", oauth_signature_method=\"HMAC-SHA1\"";
        authHeader += ", oauth_version=\"1.0\"";

        if(authParameters)
            for (var jj = 0; jj < authParameters.length; jj++)
                authHeader += ", " + authParameters[jj][0] + "=\"" + HF.percentEncode(authParameters[jj][1]) + "\"";

        if (credentials)
            authHeader += ", oauth_token=\"" + HF.percentEncode(credentials.token) + "\"";

        var requrl = url;
        var extendedUrl = "";
        if (parameters) {
            for (var kk = 0; kk < parameters.length; ++kk) {
                if (kk == 0) extendedUrl += "?";
                else extendedUrl += "&";

                extendedUrl += parameters[kk][0] + "=" + HF.percentEncodeURI(parameters[kk][1]);
            }
        }
        return {"header": authHeader, "requrl":url + extendedUrl, "ext" : extendedUrl };
    }


}
