import QtQuick 1.1

Item{
    id:localDatabase

    function getDatabase(){
        return openDatabaseSync("dropSink.db","1.0","DropSink",100000)
    }

    function initialize(){
        var db = getDatabase();
        db.transaction (function(tx){
                            tx.executeSql('CREATE TABLE IF NOT EXISTS UserInfo (accessToken varchar(30), accessSecret varchar(30))')
                        })
    }

    function readFirstTime(){
        var db = getDatabase();
        var rowCount = -1
        db.transaction(function(tx){
                           var rs = tx.executeSql('SELECT COUNT(accessToken) as rc from UserInfo');
                           rowCount = rs.rows.item(0).rc
                       })
        if(rowCount == 0)
            return true;
        else
            return false;
    }

    function readTokenInfo(){
        var db = getDatabase();
        var userToken;
        db.transaction (function (tx){
                            if(!readFirstTime())
                            {
                                var rs = tx.executeSql ('SELECT accessToken from UserInfo');
                                userToken = rs.rows.item(0).accessToken
                            }
                        })
        return userToken;
    }

    function readTokenSecret(){
        var db = getDatabase();
        var userSecret;
        db.transaction (function (tx){
                            if(!readFirstTime())
                            {
                                var rs = tx.executeSql ('SELECT accessSecret from UserInfo');
                                userSecret = rs.rows.item(0).accessSecret
                            }
                        })
        return userSecret;
    }

    function saveUserInfo(accessToken,accessTokenSecret){
        var db = getDatabase();
        db.transaction (function(tx){
                            var rs = tx.executeSql('INSERT into UserInfo VALUES (?,?)',[accessToken,accessTokenSecret])
                            console.log(rs.rowsAffected);
                        })
    }

    function deleteUserInfo(){
        var db = getDatabase();
        db.transaction (function (tx){
                            var rs = tx.executeSql('DELETE FROM UserInfo')
                            console.log(rs.rowsAffected);
                        })
    }



}
