import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "auth.js" as Auth

Page {
    id:page
    orientationLock: PageOrientation.LockPortrait
    property string name: "mainPage"

    MouseArea{
        anchors.fill: parent
        onPressed: {
            textInput.closeSoftwareInputPanel();
        }
    }

    Rectangle{
        anchors.fill: parent
        color:"#00c3df"
    }

    Text{
        id:loginText
        anchors.top: parent.top
        anchors.topMargin:100
        anchors.horizontalCenter: parent.horizontalCenter
        font.pointSize: 20
        text:"login to your Dropbox account"
    }

    Rectangle{
        id: lineRect
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: loginText.bottom
        anchors.topMargin: 10
        width:370
        height:2
        color: "black"
    }

    Text{
        id:usrNameText
        anchors.top:lineRect.bottom
        anchors.topMargin: 20
        anchors.left:parent.left
        anchors.leftMargin: 70
        font.pointSize: 15
        text:"email"
    }

    TextField{
        id:textInput
        anchors.top: usrNameText.bottom
        anchors.topMargin: 5
        anchors.horizontalCenter: parent.horizontalCenter

        width: 360
        height: 50

        font.capitalization : Font.AllLowercase
        font.pointSize: 20

        MouseArea{
            anchors.fill: parent
            onPressed: {
                textInput.openSoftwareInputPanel();
            }
        }
    }

    Text{
        id:passText
        anchors.top:textInput.bottom
        anchors.topMargin: 20
        anchors.left:parent.left
        anchors.leftMargin: 70
        font.pointSize: 15
        text:"password"
    }

    TextField{
        id:passwordInput
        anchors.top: passText.bottom
        anchors.topMargin: 5
        anchors.horizontalCenter: parent.horizontalCenter

        width: 360
        height: 50
        echoMode: TextInput.Password
        font.pointSize: 20

        MouseArea{
            anchors.fill: parent
            onPressed: {
                textInput.openSoftwareInputPanel();
            }
        }

    }

    Rectangle{
        id:loginBtn
        anchors.top: passwordInput.bottom
        anchors.topMargin: 20
        anchors.horizontalCenter: parent.horizontalCenter
        color: "black"
        border.color: "black"
        border.width: 2
        width:125
        height: 40
        radius:20
        Text{
            id:loginBtnText
            anchors.centerIn: parent
            color:"#00c3df"
            font.pointSize: 20
            text:"login"
        }

        MouseArea{
            anchors.fill: parent

            onPressed: {
                loginBtn.color = "#00c3df"
                loginBtnText.color = "black"
            }

            onReleased: {
                loginBtn.color = "black"
                loginBtnText.color = "#00c3df"
            }


            onClicked:{
                textInput.closeSoftwareInputPanel();
                passwordInput.closeSoftwareInputPanel();
                if(passwordInput.text == "" || textInput.text=="" || emailRegex(textInput.text) == false)
                {
                    banner.show();
                }
                else
                {
                    loadingScreen.show = true;
                    email = textInput.text
                    password = passwordInput.text
                    Auth.authorize(textInput.text,passwordInput.text)
                }

            }
        }
    }

    Image{
        anchors.top: loginBtn.bottom
        anchors.topMargin: 30
        anchors.horizontalCenter: parent.horizontalCenter
        source:"res/dropsinklogo.png"
    }

    Keys.onPressed: {
        if (event.key == 16777220) {
            textInput.closeSoftwareInputPanel();
            passwordInput.closeSoftwareInputPanel();
        }
    }

    DropBoxAuth{
        id:dropAuth
    }

    InfoBanner{
        id:banner
        text:"Please enter the correct email and password"
    }


    function emailRegex(emailaddress)
    {
        if (/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(emailaddress))
        {
            return true;
        }

        else
        {
            return false;
        }
    }
}
