import QtQuick 1.1
import com.nokia.meego 1.0

Sheet {
    id: sheet
    acceptButtonText: "Search"
    rejectButtonText: "Cancel"

    content: Item {
        id: sheetContent

        anchors.fill: parent

        MouseArea {
            anchors.fill: parent
            onClicked: {
                tempInput.closeSoftwareInputPanel()
            }
        }

        TextInput {
            id: tempInput
        }

        TextField {
            id: searchText
            width: 460
            height: 70
            placeholderText: "Please type in a search term"
            anchors {
                top: parent.top
                topMargin: 20
                horizontalCenter: parent.horizontalCenter
            }

            Keys.onPressed: {
                if (event.key == 16777220) {
                    tempInput.closeSoftwareInputPanel()

                }
            }
        }
    }

    onAccepted: {
        if (searchText.text != "") {
            loadingScreen.show = true;
            udm.searchFile(accessToken,accessTokenSecret,searchText.text,page.returnResult);
            searchString =searchText.text
            sheet.close()
        } else {
            banner.text = "Please type a search term"
            banner.show()
        }
    }

    onRejected: {
        sheet.close();
    }

    function clicked(name)
    {
        sheet.open();
    }

    UserDataManager{id:udm}


}
