import QtQuick 1.0
import com.nokia.meego 1.0
import "FileTypeDetector.js" as FTD

Item{
    property string icoType
    property string icoName
    property string icoModified

    width:480
    height:90

    Rectangle{
        id:backgroundRect
        width:480
        height:90
        color: "white"

        Image{
            id:folderIcon
            width: 60
            height: 60
            sourceSize.width:60
            sourceSize.height: 60


            anchors{
                left:parent.left
                leftMargin: 10
                verticalCenter: parent.verticalCenter
            }

            source:FTD.fileImage(icoType,icoName)
        }


        Item{
            width: 410
            height: (icoModified == "")? topItem.paintedHeight: topItem.paintedHeight + bottomItem.paintedHeight
            anchors.left:folderIcon.right
            anchors.leftMargin: 10
            anchors.verticalCenter: parent.verticalCenter

            Text{
                id:topItem
                font.pointSize: 25
                text:icoName

                elide: Text.ElideRight
                width: 360
            }

            Text{
                id:bottomItem
                anchors.top:topItem.bottom
                anchors.topMargin: 3
                color:"#c1c1c1"
                font.pointSize: 20
                text:icoModified

                elide: Text.ElideRight
                width: 360

            }
        }

        Rectangle{
            width:480
            height: 1
            anchors.bottom: parent.bottom
            color:"#f1f1f1"
        }

        MouseArea{
            anchors.fill: parent
            onClicked: {
                if(foldermodel.isFolder(index)  == true)
                {
                    uploadModel.append({"dir":filePath})
                    foldermodel.folder = filePath
                }

                else if(foldermodel.isFolder(index)  != true)
                {
                    selectionDialog.filePath  = filePath
                    selectionDialog.open();
                }
            }

            onPressed: changeColor();
            onReleased: changeColor();
        }
    }


    function changeColor()
    {
        if(backgroundRect.color == "#ffffff")
            backgroundRect.color = "#e4e4e4";
        else
            backgroundRect.color = "#ffffff";
    }

    function flickColor()
    {
        backgroundRect.color =  "#ffffff";
    }



}
