import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import drop.sink 1.0

PageStackWindow {
    id: appWindow

    initialPage: splashScreen
    property string requestToken:""
    property string requestTokenSecret: ""
    property string accessToken:(db.readFirstTime())? "":db.readTokenInfo()
    property string accessTokenSecret:(db.readFirstTime())? "":db.readTokenSecret()

    property string email;
    property string password;
    property variant searchString;

    Component{id:splashScreen; Splash{}}
    Component{id:mainPage; MainPage{}}
    Component{id:directoryPage; DirectoryPage{}}
    Component{id:settingPage; SettingPage{}}
    Component{id:uploadPage; UploadPage{}}
    Component{id:searchResultPage; SearchResultPage{}}
    LoadingScreen{id:loadingScreen}
    ListModel{id:directoryModel}
    ListModel{id:uploadModel}
    ListModel{id:searchDirectoryModel}
    FileHandler{id:fh}

    LocalStorage{
        id:db
    }

    Component.onCompleted: {
        db.initialize();
    }

    Item{
        id:appState

        function findPage(targetPage, pageName) {
            var isActive = false
            var result = pageStack.find(
                    function(page) {

                        if (page.name == pageName) {
                            if (page.status == 2) { // if it is active
                                // reload page
                                isActive = true
                            }
                            return true
                        }
                    })

            if (result != null) {
                if (isActive == false) {
                    // console.log("CASE #2: Page in stack, not active. Pop to page")
                    pageStack.pop(result)
                } else {
                    // console.log("CASE #3: Page in stack, currently active.")

                    // do nothing
                }

            } else if (result == null) {
                // console.log("CASE #1: Page not in stack")

                pageStack.push(targetPage)

            }
        }
    }
}
